﻿// Lightning - Actionscript 3 Version - Jim Bumgardner 2008
//
package {
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.events.MouseEvent;
	import flash.display.Graphics;

	public class Lightning
	{
		// Animated lightning by Jim Bumgardner
		//
		public var curNbrBolts = 3;     // number of bolts
		public var curColor = 0xFFFFFF; // color of lightning
		public var curThick = 1;        // thickness of bolt
		public var curDetail = 2;       // must not be zero, and probably no less than 1
		public var curDisplace = 200;   // large values take longer to render
		
		private var itsPar, gen1, gen2;
		private var graf:Graphics;

		// Recursive function to draw a lightning bolt from x1,y1 to x2,y2
		// using midpoint displacement
		//
		
		public function Lightning(itsPar:DisplayObject, gen1, gen2, slider1, slider2, slider3, slider4)
		{
			this.itsPar = itsPar;
			this.gen1 = gen1;
			this.gen2 = gen2;
			this.graf = itsPar.graphics;

			// Setup the 4 sliders...
			new SliderController(slider1,'detail',1,20, curDetail, setDetail);
			new SliderController(slider2,'thickness',.1,10, curThick,setThick);
			new SliderController(slider3,'number bolts',1,12, curNbrBolts,setNbrBolts);
			new SliderController(slider4,'displacement',1,400, curDisplace,setDisplace);
		  
			itsPar.addEventListener(Event.ENTER_FRAME, myAnimationHandler);
		}
    
		function drawLightning(x1,y1,x2,y2,displace)
		{
		  if (displace < curDetail) {
			graf.moveTo(x1,y1);
			graf.lineTo(x2,y2);
		  }
		  else {
			var mid_x = (x2+x1)/2;
			var mid_y = (y2+y1)/2;
			mid_x += (Math.random()-.5)*displace;
			mid_y += (Math.random()-.5)*displace;
			drawLightning(x1,y1,mid_x,mid_y,displace/2);
			drawLightning(x2,y2,mid_x,mid_y,displace/2);
		  }
		}
    
		function myAnimationHandler(evt:Event)
		{
		  graf = itsPar.graphics;
		  // draw a set of lightning bolts..
		  graf.clear();
		  graf.lineStyle(curThick,0xFFFFFF);
		  for (var i = 0; i < curNbrBolts; ++i)
			drawLightning(gen1.x, gen1.y,
						  gen2.x, gen2.y, 
						  curDisplace);
		}
    
		// Slider change functions - these are called when the knobs are fiddled with
		//
		public function setNbrBolts(n)
		{
		  curNbrBolts = n;
		}
		
		public function setThick(t)
		{
		  curThick = t;
		}
		
		public function setDetail(d)
		{
		  curDetail = Math.max(1,d);
		}
		
		public function setDisplace(n)
		{
		  curDisplace = n;
		}
	} // class
} // package